- block:
    - debug:
        msg: This playbook does not install azure arc in Windows 2012 and below version
    - fail:
        msg: This playbook does not run in current version of the OS
  when: "'2008' in ansible_distribution"

- name: Check the Resource Group if host is already connected to Azure-Arc
  win_shell: |
    $full_rg= azcmagent show | Select-String -Pattern "Resource Group Name                     :"
    $full_rg -split ":"
  ignore_errors: yes
  register: old_rg
  async: 120
  pool: 3

- set_fact:
    new_rg: "{{azure_arc_agent_resourceGroup}}"

- debug:
    msg: The old RG is and the new RG is not the same
  when:
    - old.rg.stdout_lines[1] != new_rg

- name: Disconnect the Arc agent if it is already connected and connected with a different RG
  win_shell:  azcmagent disconnect \
                 --azure_arc_agent_service-principal-id "{{azure_arc_agent_client_id}}" \
                 --sazure_arc_agent_ervice-principal-secret "{{azure_arc_agent_client_secret}}"
  async: 120
  pool: 3
  ignore_errors: true
  when:
    - old_rg.stdout_lines[1] != new_rg

- name: Installing Azure-Arc in Windows
  win_shell: |
    # Download the package
    function download() {$ProgressPregerence="SilentlyContinue"; Invoke-WebRequest -Uri https://aka.ms/AzureConnectedMachineAgent -OutFile AzureConnectedMachineAgent.msi}
    download

    # Install the package
    msiexec /i AzureConnectedMachineAgent.msi /l*v installationlog.txt /qn | Out-String
  async: 120
  pool: 3
  ignore_errors: true

- name: Connecting Azure-Arc with Azure Resource Group
  command: azcmagent connect \
            --azure_arc_agent_resource-group "{{azure_arc_agent_resourceGroup}}"
            --azure_arc_agent_tenant-id "{{azure_arc_agent_tenantId}}"
            --azure_arc_agent_location "{{azure_arc_agent_locatioon}}"
            --azure_arc_agent_subscription "{{azure_arc_agent_subscription}}"
            --azure_arc_agent_tags "{{azure_arc_agent_tags}}"
            --azure_arc_agent_service-principal-id "{{azure_arc_agent_client_id}}"
            --azure_arc_agent_service-principal-secret "{{azure_arc_agent_client_secret}}"
    register: final_out
    ignore_errors: yes

    - pause:

    - debug:
        msg: Successfully installed Arc-Agent on host "{{inventory_hostname}}" and registered to "{{azure_arc_agent_resourceGroup}}"
